;;; menu for ihtml (markup helping tool for iso-html or xhtml11)
;;; 2011-11-01, 2014-10-30 Ver.0.2.5.20141030
;;; http://purl.com/net/dkcc/shed/ihtml.html
;;; License: CC0
;;; for .xyzzy only (error occurs in siteinit.l)



;;; (6) package
;;; 2011-11-01, 2011-11-01

(provide "ihtml-menu")
#|
(in-package "editor")
(export
 '())
|#



;;; (5) *ihtml-popup-menu*
;;; 2006-05-21, 2012-04-04

;(eval-when (:compile-toplevel :load-toplevel :execute)
;  (require "localpop")
(defvar *ihtml-local-popup-menu-structure*
  (define-popup-menu
   (:item 'ihtml "<div>" 'ihtml-div)
   (:item 'ihtml "<p>" 'ihtml-p)
   (:sep 'ihtml)
   (:item 'ihtml "h-" 'ihtml-h-)
   (:item 'ihtml "h0" 'ihtml-h0)
   (:item 'ihtml "h+" 'ihtml-h+)
   (:sep 'ihtml)
   (:item 'ihtml "<h1>" 'ihtml-h1)
   (:item 'ihtml "<h2>" 'ihtml-h2)
   (:item 'ihtml "<h3>" 'ihtml-h3)
   (:item 'ihtml "<h4>" 'ihtml-h4)
   (:item 'ihtml "<h5>" 'ihtml-h5)
   (:item 'ihtml "<h6>" 'ihtml-h6)))
(defvar *ihtml-local-popup-menu-list*
  (define-popup-menu
   (:item 'ihtml "<dl>" 'ihtml-dl)
   (:item 'ihtml "<dt>" 'ihtml-dt)
   (:item 'ihtml "<dd>" 'ihtml-dd)
   (:sep 'ihtml)
   (:item 'ihtml "<ol>" 'ihtml-ol)
   (:item 'ihtml "<ul>" 'ihtml-ul)
   (:item 'ihtml "<li>" 'ihtml-li)))
(defvar *ihtml-local-popup-menu-others*
  (define-popup-menu
   (:item 'ihtml "<address>" 'ihtml-address)
   (:item 'ihtml "<blockquote>" 'ihtml-blockquote)
;   (:item 'ihtml "<form>" 'ihtml-form)))
   (:item 'ihtml "<pre>" 'ihtml-pre)
   (:sep 'ihtml)
   (:item 'ihtml "<hr>" 'ihtml-hr)
   (:sep 'ihtml)
   (:item 'ihtml "<meta>" 'ihtml-meta) ; 2014-10-28
   (:item 'ihtml "<link>" 'ihtml-link) ; 2014-10-28
   (:sep 'ihtml)
   (:item 'ihtml "<!--" 'ihtml-comment)
   (:item 'ihtml "any tags" 'ihtml-completing-markup)
   (:item 'ihtml "escape" 'ihtml-escape-selection)
   (:item 'ihtml "unescape" 'ihtml-unescape-selection)))
(defvar *ihtml-local-popup-menu-logical*
  (define-popup-menu
   (:item 'ihtml "<abbr>" 'ihtml-abbr)
   (:item 'ihtml "<acronym>" 'ihtml-acronym)
   (:item 'ihtml "<cite>" 'ihtml-cite)
   (:item 'ihtml "<code>" 'ihtml-code)
   (:item 'ihtml "<dfn>" 'ihtml-dfn)
   (:item 'ihtml "<em>" 'ihtml-em)
   (:item 'ihtml "<kbd>" 'ihtml-kbd)
   (:item 'ihtml "<samp>" 'ihtml-samp)
   (:item 'ihtml "<strong>" 'ihtml-strong)
   (:item 'ihtml "<var>" 'ihtml-var)))
(defvar *ihtml-local-popup-menu-physical*
  (define-popup-menu
   (:item 'ihtml "<b>" 'ihtml-b)
   (:item 'ihtml "<i>" 'ihtml-i)
   (:item 'ihtml "<sub>" 'ihtml-sub)
   (:item 'ihtml "<sup>" 'ihtml-sup)
   (:item 'ihtml "<tt>" 'ihtml-tt)))
(defvar *ihtml-local-popup-menu-special*
  (define-popup-menu
   (:item 'ihtml "<a>" 'ihtml-a-global) ; 2014-10-28
   (:item 'ihtml "<a> (local)" 'ihtml-a-local) ; 2014-10-28
   (:item 'ihtml "<a href=\"#...\">" 'ihtml-a-fragment) ; 2012-04-04
   (:item 'ihtml "<q>" 'ihtml-q)
   (:item 'ihtml "<span>" 'ihtml-span)
   (:sep 'ihtml)
   (:item 'ihtml "<br>" 'ihtml-br)
   (:item 'ihtml "<img>" 'ihtml-img)
   (:item 'ihtml "<object>" 'ihtml-object)
   (:item 'ihtml "<param>" 'ihtml-param)
   (:sep 'ihtml)
   (:item 'ihtml "<bdo>" 'ihtml-bdo)
   (:item 'ihtml "<del>" 'ihtml-del)
   (:item 'ihtml "<ins>" 'ihtml-ins)))
;   (:item 'ihtml "<ruby>" 'ihtml-ruby)))
#|
(defvar *ihtml-local-popup-menu-attr-core*
  (define-popup-menu
   (:item 'ihtml "core" 'ihtml-attr-core)
   (:sep 'ihtml)
   (:item 'ihtml "id" 'ihtml-attr-id)
   (:item 'ihtml "class" 'ihtml-attr-class)
   (:item 'ihtml "title" 'ihtml-attr-title)))
(defvar *ihtml-local-popup-menu-attr-i18n*
  (define-popup-menu
;   (:item 'ihtml "i18n" 'ihtml-attr-i18n)
;   (:sep 'ihtml)
   (:item 'ihtml "lang" 'ihtml-attr-lang)
   (:item 'ihtml "bdo" 'ihtml-attr-bdo)))
|#
(defvar *ihtml-local-popup-menu-form* ; 2014-10-29
  (define-popup-menu
   (:item 'ihtml "form" 'ihtml-form)
   (:item 'ihtml "label" 'ihtml-label)
   (:item 'ihtml "fieldset" 'ihtml-fieldset)
   (:item 'ihtml "legend" 'ihtml-legend)
   (:sep 'ihtml)
   (:item 'ihtml "input" 'ihtml-input)
   (:item 'ihtml "button" 'ihtml-button)
   (:item 'ihtml "textarea" 'ihtml-textarea)
   (:sep 'ihtml)
   (:item 'ihtml "select" 'ihtml-select)
   (:item 'ihtml "optgroup" 'ihtml-optgroup)
   (:item 'ihtml "option" 'ihtml-option)))
(defvar *ihtml-local-popup-menu-attr*
  (define-popup-menu
   (:item 'ihtml "core" 'ihtml-attr-core)
   (:sep 'ihtml)
   (:item 'ihtml "id" 'ihtml-attr-id)
   (:item 'ihtml "class" 'ihtml-attr-class)
   (:item 'ihtml "title" 'ihtml-attr-title)
   (:sep 'ihtml)
   (:item 'ihtml "lang" 'ihtml-attr-lang)
   (:item 'ihtml "bdo" 'ihtml-attr-bdo)))
(defun ihtml-init-popup-menu ()
  (defvar *ihtml-local-popup-menu*
    (let ((pm (copy-popup-menu *app-popup-menu*)))
      (add-menu-separator pm 'ihtml)
      (add-popup-menu pm *ihtml-local-popup-menu-structure* "Block > Structure")
      (add-popup-menu pm *ihtml-local-popup-menu-list* "        > List")
      (add-popup-menu pm *ihtml-local-popup-menu-others* "        > Others/Tools")
      (add-popup-menu pm *ihtml-local-popup-menu-logical* "Inline > Logical")
      (add-popup-menu pm *ihtml-local-popup-menu-physical* "        > Physical")
      (add-popup-menu pm *ihtml-local-popup-menu-special* "        > Special")
      (add-popup-menu pm *ihtml-local-popup-menu-form* "Form")
      (add-popup-menu pm *ihtml-local-popup-menu-attr* "Attributes")
      pm))
  (setq *app-popup-menu* *ihtml-local-popup-menu*))
(add-hook
 '*post-startup-hook*
 'ihtml-init-popup-menu)
;)
;(use-local-popup-menu *ihtml-local-popup-menu*)
;(makunbound '*ihtml-local-popup-menu*)
#|
(add-hook
 '*post-startup-hook*
 (lambda ()
   (defvar *ihtml-local-popup-menu*
     (let ((pm (copy-popup-menu)))
       (add-menu-separator pm 'ihtml)
;;;    (add-menu-item pm 'ihtml "* Block Elements" nil nil)
       (add-popup-menu pm *ihtml-local-popup-menu-structure* "block - Structure")
       (add-popup-menu pm *ihtml-local-popup-menu-list* "block - List")
       (add-popup-menu pm *ihtml-local-popup-menu-others* "block - Others")
;;;    (add-menu-item pm 'ihtml "* Inline Elements" nil nil)
       (add-popup-menu pm *ihtml-local-popup-menu-logical* "inline - Logical")
       (add-popup-menu pm *ihtml-local-popup-menu-physical* "inline - Physical")
       (add-popup-menu pm *ihtml-local-popup-menu-special* "inline - Special")
;;;    (add-menu-item pm 'ihtml "* Attributes" nil nil)
       (add-popup-menu pm *ihtml-local-popup-menu-attr-core* "attr - core")
       (add-popup-menu pm *ihtml-local-popup-menu-attr-i18n* "attr - i18n")
       (setq *app-popup-menu* *ihtml-local-popup-menu*)))))

(add-hook
 '*post-startup-hook*
 (lambda ()
   (defvar *ihtml-local-popup-menu*
     (let ((pm (copy-popup-menu)))
       (add-menu-separator pm 'ihtml)
       (let ((be (create-popup-menu)) (ie (create-popup-menu)))
         (add-popup-menu be *ihtml-local-popup-menu-structure* "Structure")
         (add-popup-menu be *ihtml-local-popup-menu-list* "List")
         (add-popup-menu be *ihtml-local-popup-menu-others* "Others")
         (add-popup-menu ie *ihtml-local-popup-menu-logical* "Logical")
         (add-popup-menu ie *ihtml-local-popup-menu-physical* "Physical")
         (add-popup-menu ie *ihtml-local-popup-menu-special* "Special")
;         (add-popup-menu attr *ihtml-local-popup-menu-attr-core* "core")
;         (add-popup-menu attr *ihtml-local-popup-menu-attr-i18n* "i18n")
         (add-popup-menu pm be "Block Elements")
         (add-popup-menu pm ie "Inline Elements")
;         (add-popup-menu pm attr "Attributes")
         (add-popup-menu pm *ihtml-local-popup-menu-attr* "Attributes")
         pm)))
   (setq *app-popup-menu* *ihtml-local-popup-menu*)))

(use-local-popup-menu
  (let ((pm (copy-popup-menu)))
    (add-menu-separator pm 'ihtml)
    (add-popup-menu pm *ihtml-local-popup-menu-structure* "Block > Structure")
    (add-popup-menu pm *ihtml-local-popup-menu-list* "        > List")
    (add-popup-menu pm *ihtml-local-popup-menu-others* "        > Others")
    (add-popup-menu pm *ihtml-local-popup-menu-logical* "Inline > Logical")
    (add-popup-menu pm *ihtml-local-popup-menu-physical* "        > Physical")
    (add-popup-menu pm *ihtml-local-popup-menu-special* "        > Special")
    (add-popup-menu pm *ihtml-local-popup-menu-attr* "Attributes")
    pm))

|#



#|  2006-05-26
;;; Ver.3 alist

(defvar *ihtml-popup-menu* nil)
(unless *ihtml-popup-menu*
  (setq
   *ihtml-popup-menu*
   `(("special" .
      ,(define-popup-menu
         (:item 'ihtml "a" 'ihtml-a)
         (:item 'ihtml "br" 'ihtml-br)
         (:item 'ihtml "img" 'ihtml-img)
         (:item 'ihtml "object" 'ihtml-object)
         (:item 'ihtml "q" 'ihtml-q)
         (:item 'ihtml "span" 'ihtml-span)))
     ("logical-styles" .
      ,(define-popup-menu
         (:item 'ihtml "abbr" 'ihtml-abbr)
         (:item 'ihtml "acronym" 'ihtml-acronym)
         (:item 'ihtml "cite" 'ihtml-cite)
         (:item 'ihtml "code" 'ihtml-code)
         (:item 'ihtml "dfn" 'ihtml-dfn)
         (:item 'ihtml "em" 'ihtml-em)
         (:item 'ihtml "kbd" 'ihtml-kbd)
         (:item 'ihtml "samp" 'ihtml-samp)
         (:item 'ihtml "strong" 'ihtml-strong)
         (:item 'ihtml "var" 'ihtml-var)))
     ("physical-styles" .
      ,(define-popup-menu
         (:item 'ihtml "b" 'ihtml-b)
         (:item 'ihtml "i" 'ihtml-i)
         (:item 'ihtml "sub" 'ihtml-sub)
         (:item 'ihtml "sup" 'ihtml-sup)
         (:item 'ihtml "tt" 'ihtml-tt)))
     ("structure" .
      ,(define-popup-menu
         (:item 'ihtml "h-" 'ihtml-h-)
         (:item 'ihtml "h0" 'ihtml-h0)
         (:item 'ihtml "h+" 'ihtml-h+)
         (:item 'ihtml "h1" 'ihtml-h1)
         (:item 'ihtml "h2" 'ihtml-h2)
         (:item 'ihtml "h3" 'ihtml-h3)
         (:item 'ihtml "h4" 'ihtml-h4)
         (:item 'ihtml "h5" 'ihtml-h5)
         (:item 'ihtml "h6" 'ihtml-h6)
         (:item 'ihtml "div" 'ihtml-div)
         (:item 'ihtml "p" 'ihtml-p)))
     ("attribute" .
      ,(define-popup-menu
         (:item 'ihtml "core" 'ihtml-attr-core)
         (:item 'ihtml "id" 'ihtml-attr-id)
         (:item 'ihtml "class" 'ihtml-attr-class)
         (:item 'ihtml "title" 'ihtml-attr-title)
         (:item 'ihtml "lang" 'ihtml-attr-lang))))))
(defun ihtml-add-popup-menu ()
  (add-menu-separator *app-popup-menu* 'ihtml-start)
  (dolist (menu *ihtml-popup-menu*)
    (add-popup-menu *app-popup-menu* (cdr menu) (car menu))))
(add-hook '*init-app-menus-hook* #'ihtml-add-popup-menu)

;;; Ver.2 alist & hash-table
(defvar *ihtml-popup-menu-name*
  '((special . "special")
    (logical-styles . "logical-styles")
    (physical-styles . "physical-styles"))
  "alist: ((hash-key . menu-name) ...)")
(defvar *ihtml-popup-menu* nil)
(unless *ihtml-popup-menu*
  (setq *ihtml-popup-menu* (make-hash-table))
  (setf
   (gethash 'special *ihtml-popup-menu*)
   (define-popup-menu
     (:item 'ihtml "a" 'ihtml-a)
     (:item 'ihtml "br" 'ihtml-br)
     (:item 'ihtml "object" 'ihtml-object)
     (:item 'ihtml "q" 'ihtml-q)
     (:item 'ihtml "span" 'ihtml-span)))
  (setf
   (gethash 'logical-styles *ihtml-popup-menu*)
   (define-popup-menu
     (:item 'ihtml "abbr" 'ihtml-abbr)
     (:item 'ihtml "acronym" 'ihtml-acronym)
     (:item 'ihtml "cite" 'ihtml-cite)
     (:item 'ihtml "code" 'ihtml-code)
     (:item 'ihtml "dfn" 'ihtml-dfn)
     (:item 'ihtml "em" 'ihtml-em)
     (:item 'ihtml "kbd" 'ihtml-kbd)
     (:item 'ihtml "samp" 'ihtml-samp)
     (:item 'ihtml "strong" 'ihtml-strong)
     (:item 'ihtml "var" 'ihtml-var)))
  (setf
   (gethash 'physical-styles *ihtml-popup-menu*)
   (define-popup-menu
     (:item 'ihtml "b" 'ihtml-b)
     (:item 'ihtml "i" 'ihtml-i)
     (:item 'ihtml "sub" 'ihtml-sub)
     (:item 'ihtml "sup" 'ihtml-sup)
     (:item 'ihtml "tt" 'ihtml-tt))))
(defun ihtml-add-popup-menu ()
  (add-menu-separator *app-popup-menu* 'ihtml)
  (dolist (name *ihtml-popup-menu-name*)
    (add-popup-menu *app-popup-menu* (gethash (car name) *ihtml-popup-menu*) (cdr name))))
(add-hook '*init-app-menus-hook* #'ihtml-add-popup-menu)
|#

#| ;;; Ver.1 variables
(defvar *ihtml-popup-special* nil)
(defvar *ihtml-popup-logical-styles* nil)
(defvar *ihtml-popup-physical-styles* nil)
(unless )
(setq
 *ihtml-popup-special*
 (define-popup-menu
   (:item 'ihtml "a" 'ihtml-a)
   (:item 'ihtml "br" 'ihtml-br)
   (:item 'ihtml "object" 'ihtml-object)
   (:item 'ihtml "q" 'ihtml-q)
   (:item 'ihtml "span" 'ihtml-span))
 *ihtml-popup-logical-styles*
 (define-popup-menu
   (:item 'ihtml "abbr" 'ihtml-abbr)
   (:item 'ihtml "acronym" 'ihtml-acronym)
   (:item 'ihtml "cite" 'ihtml-cite)
   (:item 'ihtml "code" 'ihtml-code)
   (:item 'ihtml "dfn" 'ihtml-dfn)
   (:item 'ihtml "em" 'ihtml-em)
   (:item 'ihtml "kbd" 'ihtml-kbd)
   (:item 'ihtml "samp" 'ihtml-samp)
   (:item 'ihtml "strong" 'ihtml-strong)
   (:item 'ihtml "var" 'ihtml-var))
 *ihtml-popup-physical-styles*
 (define-popup-menu
   (:item 'ihtml "b" 'ihtml-b)
   (:item 'ihtml "i" 'ihtml-i)
   (:item 'ihtml "sub" 'ihtml-sub)
   (:item 'ihtml "sup" 'ihtml-sup)
   (:item 'ihtml "tt" 'ihtml-tt)))
(defun ihtml-add-popup-menu ()
  (add-menu-separator *app-popup-menu* 'ihtml)
  (add-popup-menu *app-popup-menu* *ihtml-popup-special* "special")
  (add-popup-menu *app-popup-menu* *ihtml-popup-logical-styles* "logical-styles")
  (add-popup-menu *app-popup-menu* *ihtml-popup-physical-styles* "physical-styles"))
(add-hook '*init-app-menus-hook* #'ihtml-add-popup-menu)
|#

#|
(setq ihtml-popup-menu (create-popup-menu 'ihtml))
(add-menu-separator *app-popup-menu* 'ihtml)
(add-popup-menu
 ihtml-popup-menu
 (define-popup-menu
   (:item 'ihtml "em" 'ihtml-em)
   (:item 'ihtml "strong" 'ihtml-strong))
 "Logical")
(add-popup-menu
 ihtml-popup-menu
 (define-popup-menu
   (:item 'ihtml "a" 'ihtml-a)
   (:item 'ihtml "ins" 'ihtml-ins)
   (:item 'ihtml "del" 'ihtml-del))
 "Special")
(add-popup-menu
 *app-popup-menu*
 ihtml-popup-menu
 "HTML")
(delete-menu *app-popup-menu* 'ihtml)

(dolist (x '(b i sub sup tt))
  (format t "(:item 'ihtml \"~A\" 'ihtml-~A)\n" x x))

(make-local-variable '*app-popup-menu*)
(add-menu-separator *app-popup-menu*)
(add-popup-menu
 *app-popup-menu*
 (define-popup-menu
   (:item 'ihtml "ins" 'ihtml-ins)
   (:item 'ihtml "del" 'ihtml-del))
 "HTML")
(delete-menu *app-popup-menu* 'ihtml)
#<menu 112994980>
|#




#|
;;; Before: RBtnUp => mouse-menu-popup
;;; After:  RBtnUp => ihtml-menu-popup-hook (.x?html?$) => ihtml-menu-popup
;;;                                     (ohterwise) => mouse-menu-popup

(defun ihtml-mouse-menu-popup ()
  (interactive)
  (if (member buffer-mode '(html-mode html+-mode))
      (save-variables
       (*app-popup-menu*)
       (add-menu-separator *app-popup-menu*)
       (mouse-menu-popup))
    (mouse-menu-popup)))
ihtml-mouse-menu-popup

(setq bak (create-popup-menu))
#<menu 131674084>

(copy-menu-items *app-popup-menu* bak)
#<menu 131674084>

(track-popup-menu *app-popup-menu*)
nil

(track-popup-menu bak)
nil




(defvar *ihtml-app-popup-menu*
  (let ((menu (create-popup-menu)))
    (copy-menu-items *app-popup-menu* menu)
    (add-menu-separator menu 'ihtml)
    (dolist (item *ihtml-popup-menu*)
      (add-popup-menu menu (cdr item) (car item)))
    menu))
*ihtml-app-popup-menu*

(track-popup-menu *ihtml-app-popup-menu*)
nil

(makunbound '*ihtml-app-popup-menu*)
*ihtml-app-popup-menu*




(defmacro save-popup-menus (&body body)
  `(let ((menu-t (gensym)))
     (setq menu-t (create-popup-menu))
     (copy-menu-items *app-popup-menu* menu-t)
     (progn ,@body)
     (setq *app-popup-menu* menu-t)))
save-popup-menus

(pme (save-popup-menus
      (setq *app-popup-menu* *ihtml-app-popup-menu*)
      (mouse-menu-popup)))
(let ((menu-t (gensym)))
 (setq menu-t (create-popup-menu))
 (copy-menu-items *app-popup-menu* menu-t)
 (progn (setq *app-popup-menu* *ihtml-app-popup-menu*)
 (mouse-menu-popup))
 (setq *app-popup-menu* menu-t))
nil




(defvar-local local-popup-menu nil)
local-popup-menu
nil

(setq local-popup-menu *ihtml-app-popup-menu*)
#<menu 131674064>

(defun mouse-menu-popup-local ()
  (interactive)
  (if local-popup-menu
      (save-popup-menus
       (setq *app-popup-menu* local-popup-menu)
       (mouse-menu-popup))
    (mouse-menu-popup)))
mouse-menu-popup-local

(mouse-menu-popup-local)
#<menu 131674004>

(mouse-menu-popup)
nil

(defun use-local-popup-menu (menu)
  (setq local-popup-menu menu))
use-local-popup-menu

;(global-set-key #\RBtnUp 'mouse-menu-popup-local)
;t

(setq *global-keymap* (substitute 'mouse-menu-popup-local 'mouse-menu-popup *global-keymap*))


|#
